#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include "display.h"

#define PORT_R 51000
#define PORT_S 51001
#define M_MAX 1024

void display_send(char data){
  int sock_s;
  struct sockaddr_in addr_s;
  char buf[1];

  sock_s=socket(AF_INET,SOCK_STREAM,0);
  if(sock_s<0){
    perror("socket");
  }

  addr_s.sin_family=AF_INET;
  addr_s.sin_port=htons(PORT_S);
  addr_s.sin_addr.s_addr=inet_addr("127.0.0.1");

  connect(sock_s,(struct sockaddr*)&addr_s,sizeof(struct sockaddr_in));
  printf("send ready\n");

  buf[0]=data;
  printf("send:%c\n",buf[0]);
  send(sock_s,buf,1,0);
}

int display_wait(){
  int sock_r;
  struct sockaddr_in addr;
  int c_socket;
  socklen_t len=sizeof(struct sockaddr_in);
  struct sockaddr_in from_addr;
  int rsize;
  char buf[M_MAX];

  sock_r=socket(AF_INET,SOCK_STREAM,0);
  if(sock_r<0){
    perror("socket");
  }

  addr.sin_family=AF_INET;
  addr.sin_port=htons(PORT_R);
  addr.sin_addr.s_addr=inet_addr("127.0.0.1");

  if(bind(sock_r,(struct sockaddr*)&addr,sizeof(struct sockaddr_in))<0){
    perror("bind");
  }
  if(listen(sock_r,SOMAXCONN)<0){
    perror("listen");
  }
  c_socket=accept(sock_r,(struct sockaddr*)&from_addr,&len);
  if(c_socket<0){
    perror("accept");
  }
  memset(buf,0,sizeof(buf));

  while(buf[0]==0){
    rsize=recv(c_socket,&buf,M_MAX,0);
  }
  int figure=buf[0];
  return figure;
}
