#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <wiringSerial.h>
#include "gps.h"

void gps_get(double gps[2]){
	int fd,i;
	double north = 0;
	double east = 0;
	fd = serialOpen("/dev/serial0",9600);
	if(fd < 0){
		printf("failed to open serial");
	}else{
		printf("serial opened\n");

		while(1){
			i = serialGetchar(fd);
			if(i == '$'){
				i = serialGetchar(fd);
				i = serialGetchar(fd);
				i = serialGetchar(fd);
				if(i == 'G'){
					i = serialGetchar(fd);
					if(i == 'L'){
						i = serialGetchar(fd);
						if(i == 'L'){
							north = 0;
							east = 0;
							while(i != '$'){
								i = serialGetchar(fd);
								if(i != ',' && i != '.'){
									if(i == 'N'){
										break;
									}else{
										north = north * 10 + cdetect(i);
									}
								}
							}
							while(i != '$'){
								i = serialGetchar(fd);
								if(i != ',' && i != '.'){
									if(i == 'E'){
										break;
									}else{
										east = east * 10 + cdetect(i);
									}
								}
							}
							north *= 0.000001;
							east *= 0.000001;
							if(north > 90 || east > 180){
								printf("Can't read GPS\n");
							}else{
								printf("北緯%lf° 東経%lf°\n",north,east);
                break;
							}
						}
					}
				}
			}
		}

    gps[0] = north;
    gps[1] = east;
		printf("\n");
	}
}

double cdetect(int c){
	switch(c){
		case '0':
			return 0;
		case '1':
			return 1;
		case '2':
			return 2;
		case '3':
			return 3;
		case '4':
			return 4;
		case '5':
			return 5;
		case '6':
			return 6;
		case '7':
			return 7;
		case '8':
			return 8;
		case '9':
			return 9;
		default:
			return 0;
	}
}
