#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "switch.h"
#include "request.h"
#include "run.h"
#include "display.h"

int *line_onoff;

int main(){
  int course_num = 1;

  if(switch_open() != 0) return -1;
	if(arduino_open() != 0) return -1;

  //printf("press enter to start\n");
  //getchar();
  course_num = display_wait();
  printf("recv:%d\n",course_num);
  usleep(1000*1000);
  run(course_num);
  display_send('f');

  arduino_close();
  return 0;
}
