#include <stdio.h>
#include "arduino.h"
#include "request.h"
#include <wiringPi.h>
#include "switch.h"
#include <unistd.h>

int main(){
	int sw1,sw2,sw3;
	int sw1b = 1;
	int sw2b = 1;
	int sw3b = 1;
	char buf[256];
	int str_speed;
	int rot_speed;
	
	if(arduino_open() != 0) return -1;
	if(switch_open() != 0) return -1;
	
	printf("決定＋右でバック,全押しでbreak\n");
	printf("str_speed? [cm/s]\n");
	fgets(buf, sizeof(buf), stdin);
	sscanf(buf, "%d", &str_speed);
	printf("rot_speed? [deg]\n");
	fgets(buf, sizeof(buf), stdin);
	sscanf(buf, "%d", &rot_speed);
	while(1){
		switch_get(&sw1, &sw2, &sw3);
		if(sw1 != sw1b || sw2 != sw2b || sw3 != sw3b){
			if(sw1 == 1 && sw2 == 0 && sw3 == 1){
				request_set_runmode(ROT,rot_speed,-40000);
			}else if(sw1 == 0 && sw2 == 1 && sw3 == 1){
				request_set_runmode(STR,str_speed,30000);
			}else if(sw1 == 1 && sw2 == 1 && sw3 == 0){
				request_set_runmode(ROT,rot_speed,40000);
			}else if(sw1 == 0 && sw2 == 1 && sw3 == 0){
				request_set_runmode(STR,str_speed,-30000);
			}else if(sw1 == 0 && sw2 == 0 && sw3 == 1){
				request_set_line(40);
			}else if(sw1 == 0 && sw2 == 0 && sw3 == 0){
				request_set_runmode(STP, 0, 0);
				request_set_line(0);
				printf("str_speed? [cm/s]\n");
				fgets(buf, sizeof(buf), stdin);
				sscanf(buf, "%d", &str_speed);
				printf("rot_speed? [deg]\n");
				fgets(buf, sizeof(buf), stdin);
				sscanf(buf, "%d", &rot_speed);
				if(str_speed == 0 && rot_speed == 0){
					printf("break\n");
					break;
				}
			}else{
				request_set_runmode(STP, 0, 0);
				request_set_line(0);
			}
		}
		usleep(100 * 1000);
		sw1b = sw1;
		sw2b = sw2;
		sw3b = sw3;
	}
}
