#include <stdio.h>
#include <unistd.h>
#include "run.h"
#include "line.h"
#include "marker.h"
#include "request.h"
#include "flag.h"

#define LONG 40

void stop_detect();

run_state_t run_state;
int speed;
int dist;
int *line_onoff;

void run(int run_state_t){
  speed = 30;
  switch (run_state_t) {
  	case 1:
        request_set_runmode(STR, speed, 100);
        stop_detect();
        request_set_marker(90);
        request_set_runmode(STR, speed, -10);
        stop_detect();
        request_set_runmode(STR, 20, 10);
        stop_detect();
  		break;
    case 2:
      request_set_line(20);
      request_set_runmode(STR, speed, 60);
      stop_detect();
      for(int i = 0; i < 4; i++){
        if(i != 4){
          request_set_line(20);
        }
        request_set_runmode(STR, speed, 40);
        stop_detect();
        request_set_line(0);
        request_set_runmode(STR, 20, 20);
        stop_detect();
        request_set_runmode(ROT, speed, 88);
        stop_detect();
        request_set_runmode(STR, 20, -20);
        stop_detect();
        request_set_line(20);
        request_set_runmode(STR, speed, 60);
        stop_detect();
        request_set_line(0);
        request_set_marker(90);
        usleep(3000*1000);
        request_set_runmode(STR, speed, -10);
        stop_detect();
        request_set_runmode(STR, 20, 10);
        stop_detect();
      }
      break;
    case 3:
      request_set_runmode(STR, speed, 60);
      stop_detect();
      for(int i = 0; i < 4; i++){
        request_set_runmode(STR, speed, 40);
        stop_detect();
        request_set_runmode(STR, 20, 20);
        stop_detect();
        request_set_runmode(ROT, speed, 88);
        stop_detect();
        request_set_runmode(STR, 20, -20);
        stop_detect();
        request_set_runmode(STR, speed, 60);
        stop_detect();
        request_set_marker(90);
        usleep(3000*1000);
        request_set_runmode(STR, speed, -10);
        stop_detect();
        request_set_runmode(STR, 20, 10);
        stop_detect();
      }
      break;
    case 4:
			request_set_line(20);
			request_set_runmode(STR, speed, 90);
			stop_detect();
			for(int i = 0; i < 4; i++){
				request_set_line(20);
				request_set_runmode(STR, speed, 90);
				stop_detect();
				request_set_line(0);
				request_set_runmode(STR, 20, 20);
				stop_detect();
				request_set_runmode(ROT, speed, 88);
				stop_detect();
				request_set_runmode(STR, 20, -20);
				stop_detect();
				request_set_line(20);
				request_set_runmode(STR, speed, 60);
				stop_detect();
				request_set_line(0);
				request_set_marker(91);
				usleep(3000*1000);
				request_set_runmode(STR, speed, -10);
				stop_detect();
				request_set_runmode(STR, 20, 10);
				stop_detect();
			}
			request_set_runmode(STR, speed, 30);
			stop_detect();
			request_set_runmode(ROT, speed, 88);
			stop_detect();
			request_set_runmode(STR, speed, 75);
			stop_detect();
			break;
    default:
      request_set_runmode(STP, 0, 0);
      break;
  }
  printf("End\n");
}

void stop_detect(){
  do {
    request_get_runmode(&run_state, &speed, &dist);
    usleep(100*1000);
  }while(run_state != STP);
}
